from meta import util

"""
Options - Unvisited: 
    1. Inspect Horse
    2. Investigate around stables
    3. Leave
    
Options - Visited: 
    1. Feed chickens
    2. Clean up the mess
    3. Leave

Areas Adjacent:
    PC's House
    Town Center
    
Monsters:
    None

People:
    None
    
Requirements:
    None
    
Exit condition:
    self.flag_inspect_horse = True
    self.flag_inspect_behind_stables = True

"""


# Naming convention is ScenarioYourArea
class ScenarioStables(object):
    def __init__(self, nav, player):
        self.PC = player
        self.nav = nav
        self.name = "The Stables"
        self.initial_description = """
Whatever you want to put here is fine.        
        """
        self.flag_inspect_horse = False
        self.flag_inspect_behind_stables = False
        self.flag_visited = False
        self.exiting = False
        self.exit_condition = False

    def inspect_horse(self):
        print("Text about looking at the horse")
        self.flag_inspect_horse = True

    def investigate_stable(self):
        print("Text about looking at the stable")
        self.flag_inspect_behind_stables = True

    def leave(self):
        print("You walk out of here, only if you're done looking at shit.")
        self.flag_visited = True
        self.exiting = True

    def start(self):
        if self.flag_visited:
            self.visited()
        else:
            self.unvisited()

    def unvisited(self):
        # Option list to print out
        options = ["Inspect Horse", "Investigate around stables"]
        # Function list to execute when menu option is selected (MAKE SURE TO NOT PUT ())
        exec = [self.inspect_horse, self.investigate_stable]
        ev = util.EventHandler()
        print(self.initial_description)
        ev.wait_for_user()
        util.clear()
        while not self.exiting:
            # Do this if both flags are True
            if self.flag_inspect_behind_stables and self.flag_inspect_horse:
                if not self.exit_condition:
                    options.append("Leave")
                    exec.append(self.leave)
                self.exit_condition = True
            util.menu_generator(options, exec)
        self.nav.travel()

    # Different methods need to be added for this to work, leaving for now.
    def visited(self):
        pass


